package redis

import (
	"net"
	"testing"

	"git.loafle.net/overflow/overflow_discovery/service/matcher"
)

const (
	ADDR string = "192.168.1.16:26379"
)

func TestRedisMatcher(t *testing.T) {

	m := NewMatcher()

	conn, _ := net.Dial("tcp", ADDR)
	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {

		pack := m.Packet(i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)

		p := matcher.NewPacket(bytes, n)

		if m.Match(nil, i, p) {
			t.Log("Redis found.")
			return
		}

		t.Error("Redis not found")
	}

}
